<?php
/*
Copyright (c) 2008 Torbjrn Lnnemark <tobbez@ryara.net>

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

function surround($input)
{
   return '"' . $input . '"';
}
?>
<html>
  <head>
    <title>Flash cycler</title>

    <script language="JavaScript">
       <?php // Config variables ?>
       var cycleTime = 20000; <?php // Time every flash should be shown ?>
       <?php $flash_dir = "swf/"; // Directory where the flash files are. 
	                          // Value must end with a slash (/) ?>

       <?php // Internally used variables ?>
       var intervalId = 0;
       var currentFlash = 0;

       <?php // Create array with all available flash files
	  echo "var flashFiles = new Array(" . 
               implode(",", array_map(surround, glob($flash_dir."*.swf"))).");";
       ?>

       <?php // Loads the current flash into the web page ?>
       function loadFlash()
       {
	 if(currentFlash >= flashFiles.length) currentFlash = 0;
         if(currentFlash < 0) currentFlash = flashFiles.length - 1;

         var fldiv = document.getElementById("divFlash");
         fldiv.innerHTML = '<embed id="emFlash" src="' + 
			   flashFiles[currentFlash] + 
			   '" width="100%" height="100%">';

	 var currentLink = document.getElementById("aCurrent");
	 currentLink.href = flashFiles[currentFlash];
	 currentLink.innerHTML = flashFiles[currentFlash];
       }
       <?php // Move to the next flash ?>
       function cycleFlash()
       {
	 currentFlash++;
	 loadFlash();
       }
       <?php // Starts moving through the flash files ?>
       function cycleStart()
       {
	 intervalId = setInterval("cycleFlash()", cycleTime);

	 var startObj = document.getElementById("aStart");
	 startObj.style.display = "none";

	 var stopObj = document.getElementById("aStop");
	 stopObj.style.display = "inline";
       }
       <?php // Stops the cycling ?>
       function cycleStop()
       {
	 clearInterval(intervalId);

         var startObj = document.getElementById("aStart");
         startObj.style.display = "inline";

         var stopObj = document.getElementById("aStop");
         stopObj.style.display = "none";

       }
       <?php // Unloads the flash object from the web page ?>
       function cycleUnload()
       {
	 var fldiv = document.getElementById("divFlash");
         fldiv.innerHTML = "";
       }
       function showAbout()
       {
         var divfl = document.getElementById("divFlash");
         divfl.innerHTML =
                "cycles through all available<br>" +
                "flash files, waiting the time<br>" +
                "specified in the source<br>" +
                "between changes.<br><br>" +
                "it is also possible to stop<br>" +
                "the cycling and browse<br>" +
                "through the files manually.<br><br>" +
                "press '(re)load' to get back<br>" +
                "<br>" +
                "<br>" +
                "copyright (c) 2008 <br>" +
                "torbjrn lnnemark <br>" +
                "&lt;<a href=mailto:tobbez@ryara.net>tobbez@ryara.net</a>&gt;";
       }
    </script>
    <style type="text/css">
      body
      {
        background-color: #000;
        color: #fff;
        font-family: "Tahoma";
        font-size: smaller;
      }
      a
      {
        color: #bbb;
        text-decoration: none;
      }
      a:hover
      {
        color: white;
      }
      #divFlash
      {
        width: 90%;
        height: 90%;
        margin-left: auto;
        margin-right: auto;
        text-align: center;
      }
      #divControl
      {
        width: 40%;
        text-align: center;
        margin-left: auto;
        margin-right: auto;
        margin-bottom: 10px;
        background-color: #434343;
      }
      #spanUnReload
      {
        float: right;
      }
      #divUnReload
      {
        position: absolute;
        top: 0px;
        right: 0px;
      }
      #divAbout
      {
        position: absolute;
        top: 0px;
        left: 0px;
      }
    </style>
  </head>
  <body onload="loadFlash();cycleStart();">
    <div id="divControl" style="position:relative;">
      <a id="aCurrent"  href=""></a>
      <br>
      <a id="aPrevious" href="#" onclick="currentFlash--;loadFlash();">
	&lt;&lt;
      </a>
      <a id="aStart" href="#" onclick="cycleStart();">start</a>
      <a id="aStop" href="#" onclick="cycleStop();">stop</a>
      <a id="aNext" href="#" onclick="currentFlash++;loadFlash();">
	&gt;&gt;
      </a>
      <div id="divUnReload">
	<a id="aUnload" href="#" onclick="cycleStop();cycleUnload();" >
	  unload
	</a>
	<br>
	<a id="aReload" href="#" onclick="loadFlash();">(re)load</a>
      </div>
    <div id="divAbout">
      <a href="#" onclick="cycleStop();showAbout();">about</a>
    </div>
    </div>
    <div id="divFlash"></div>
  </body>
</html>
